#ifndef INTERACTABLEGROUNDITEM_HPP_INCLUDED
#define INTERACTABLEGROUNDITEM_HPP_INCLUDED

#include "../../Core/Classes/GroundItem.hpp"
#include "../../Core/Classes/ItemInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Box.hpp"
#include "../../Core/Types/Convex.hpp"
#include "../../Core/Input.hpp"
#include <cstdint>

namespace Interactable
{
    class GroundItem : public Internal::GroundItem
    {
        private:
            Tile LocalTile;
        public:
            GroundItem(const Internal::GroundItem& G);
            GroundItem(const Internal::GroundItem& G, const Tile& LocalTile);
            GroundItem(const GroundItem& G);

            std::string GetName() const;
            Internal::ItemInfo GetInfo() const;

            std::vector<Point> GetModel() const;
            Convex GetConvex() const;
            Box GetBox() const;
            Point GetPoint() const;

            double GetVisibility() const;
            Tile GetTile() const;
            Tile GetLocalTile() const;
            // Angle - Calculates the angle you the tile to be in relation to your player, 0 = north, 90 = east, 180 = south, 270 = west
            void RotateTo(std::int32_t Angle = 0) const;

            bool Interact(const Button& B = BUTTON_LEFT) const;
            bool Interact(const std::string& Option) const;
            bool Interact(const std::vector<std::string>& Options) const;

            operator Internal::GroundItem() const;
    };
}


#endif // INTERACTABLEGROUNDITEM_HPP_INCLUDED
