#ifndef MINIMAP_HPP_INCLUDED
#define MINIMAP_HPP_INCLUDED

#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Classes/Region.hpp"
#include <cstdint>

/** @addtogroup Interfaces
* @{ */
class Minimap
{
    public:
        static Point GetMiddle();
        static Tile GetPosition();

        static std::int32_t GetPlane();
        static std::int32_t GetPositionX();
        static std::int32_t GetPositionY();

        static Tile GetDestination();
        static std::int32_t GetDestinationX();
        static std::int32_t GetDestinationY();

        static bool CloseTo(Tile T, std::int32_t Distance);
        static bool TileOnMM(Tile T);

        static double GetCompassAngle();
        // Angle - Calculates the angle you the tile to be in relation to your player, 0 = north, 90 = east, 180 = south, 270 = west
        static void RotateTo(const Tile& T, std::int32_t Angle = 0);
        static void RotateCompass(std::int32_t Degrees);
};

/** @} */

#endif // MINIMAP_HPP_INCLUDED
